unit uManagerVc;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fCtrls, ImgList, ComCtrls, ToolWin, ExtCtrls, DB, ADODB,
  IniFiles, AdoConEd, Grids, DBGrids, fDBCtrls, StdCtrls, ValEdit, DBCtrls,
  DateUtils, Buttons, Vector_TLB;

type
  TfMain = class(TForm)
    fsManager: TfsManager;
    cnn: TADOConnection;
    ilIcons: TImageList;
    pObj: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    Splitter2: TSplitter;
    pTime: TPanel;
    tbObjs: TToolBar;
    tbAddObj: TToolButton;
    ToolButton3: TToolButton;
    tbReqObjs: TToolButton;
    gObjs: TfsDBGrid;
    q: TADOQuery;
    dsObjs: TDataSource;
    qObjs: TADOQuery;
    Props: TADODataSet;
    Propsid: TAutoIncField;
    PropsName: TWideStringField;
    PropsType: TWideStringField;
    cbOnBeginDay: TfsCheckBox;
    vDate: TfsDateTimePicker;
    vTime: TfsDateTimePicker;
    sg: TfsStringGrid;
    msg: TfsDBMemo;
    cbValue: TfsComboBox;
    bHist: TfsBitBtn;
    gHist: TfsDBGrid;
    qHist: TADOQuery;
    dsHist: TDataSource;
    pHist: TPanel;
    procedure bCnnClick(Sender: TObject);
    procedure bTestClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure tbReqObjsClick(Sender: TObject);
    procedure gObjsKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure gObjsMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EndEditValue(SetEditText: String);
    procedure sgSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure sgDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure cbValueExit(Sender: TObject);
    procedure vDateChange(Sender: TObject);
    procedure vTimeChange(Sender: TObject);
    procedure cbOnBeginDayClick(Sender: TObject);
    procedure tbAddObjClick(Sender: TObject);
    procedure bHistClick(Sender: TObject);
  private
    { Private declarations }
    Obj: IasVc;
    procedure UpdProps;
    function AttemptConnection: boolean;
    procedure ChangeDateTime;
    procedure UpdateOptions(const Grid: TStringGrid;
      const Combo: TfsComboBox; const ACol, ARow: Integer);
  public
    { Public declarations }
  end;

const
  RowHeights: integer = 18;
  SymWidths: integer = 625; //    

var
  fMain: TfMain;
  IniFile: TIniFile;
  //NamBD,NamSrv: string;
  ExStart: boolean = false;
  NamBD,NamSrv: OleVariant;
  CurValue: variant;
  fAllProp: boolean = false;

  NumEvent: integer = 0;
  msgTxt,NamProp: string;


implementation

{$R *.dfm}

const
  OPTION_NAME_COL = 0;
  OPTION_VALUE_COL = 1;


procedure TfMain.bCnnClick(Sender: TObject);
begin
{  try
    Obj := CoasvVc.Create;
  except
    //MessageBox(0, PChar('    .'), PChar(fMain.Caption), MB_OK);
    MessageBox(Handle,'    .','',8240);
    Raise;
  end; {try}
//  FIVc.
end;

procedure TfMain.bTestClick(Sender: TObject);
begin
//  Obj.ObjCreate('');
end;

function TfMain.AttemptConnection: boolean;
begin
  result := true;
  try cnn.Open;
  except result := false;
  end;
end;

procedure TfMain.ChangeDateTime;
begin
  Obj.DateTime :=
  EncodeDateTime(YearOf(vDate.Date),
                 MonthOf(vDate.Date),
                 DayOf(vDate.Date),
                 HourOf(vTime.Time),
                 MinuteOf(vTime.Time),
                 SecondOf(vTime.Time),
                 0);
  UpdProps;
end;

procedure TfMain.UpdProps;
  var
    i: integer;
    x, y, w: integer;
    //s: string;
    maxwidth: integer;
begin
  if qObjs.IsEmpty then exit;
  if not Obj.Active then exit;
  i := 1;
  // StringGrid
  sg.Cells[0,0] := '';
  sg.Cells[1,0] := '';
  sg.ColCount := 2;
  sg.RowCount := i;
  Props.First;
  while not Props.Eof do
  begin
    CurValue := Obj.Value[qObjs.FieldValues['id'], Propsid.AsInteger];
    if VarIsNull(CurValue) and fAllProp then
    begin
      sg.Cells[0,i] := PropsName.AsString;
      sg.Cells[1,i] := 'null';
      inc(i);
    end
    else if not VarIsNull(CurValue) then
    begin
      sg.Cells[0,i] := PropsName.AsString;
      sg.Cells[1,i] := CurValue;
      inc(i);
    end;
    sg.RowCount := i;
    //sg.RowHeights[i-1] := RowHeights; //  
    Props.Next;
  end;
  sg.RowCount := i;
  if i > 1 then
  begin
    sg.FixedRows := 1;
    //sg.RowCount := 1;
  end else exit;
  //   
  with sg do
  begin
    clientheight := defaultrowheight * rowcount + 5;
    with sg do
    begin
      for x := 0 to colcount - 1 do
      begin
        maxwidth := 0;
        for y := 0 to rowcount - 1 do
        begin
          w := canvas.textwidth(cells[x,y]);
          if w > maxwidth then
            maxwidth := w;
        end;
        colwidths[x] := maxwidth + 5;
      end;
    end;
  end;
  sg.ColWidths[1] := sg.ColWidths[1]+15;
end;

procedure TfMain.FormCreate(Sender: TObject);
var
  Path: string;
  StrCnn,StrCnnDop: WideString;
begin
  cnn.Close;

  Path := ExtractFileDir(Application.ExeName);
  if Path[Length(Path)]<>'\' then Path := Path + '\';
  IniFile := TIniFile.Create(Path+'cfg.ini');

  NamBD := ParamStr(1);NamSrv := ParamStr(2);
  if (NamBD <> '') and (NamSrv <> '') then ExStart := true;
  //    
  if ExStart then begin
    StrCnn :=
            'Provider=SQLOLEDB.1;'+
            'Integrated Security=SSPI;'+
            'Persist Security Info=False;'+
            'Initial Catalog='+NamBD+';'+
            'Data Source='+NamSrv+';'+
            'Use Procedure for Prepare=1;'+
            'Auto Translate=True;'+
            'Packet Size=4096;';
    StrCnnDop :=
            'Workstation ID=Unknown;'+
            'Use Encryption for Data=False;'+
            'Tag with column collation when possible=False';
    cnn.ConnectionString := StrCnn + StrCnnDop;
  end else cnn.ConnectionString := IniFile.ReadString('Main','StrCnn','');

  if cnn.ConnectionString = '' then EditConnectionString(cnn); //   AdoConEd
  while not AttemptConnection do begin
    EditConnectionString(cnn); //   AdoConEd
  end;

  if not ExStart then IniFile.WriteString('Main', 'StrCnn', cnn.ConnectionString);

  try
    Obj := CoasVc.Create;  // Auto Serv Vector
    Obj.ObjCreate(cnn.ConnectionString);
  except
    //MessageBox(0, PChar('    .'), PChar(fMain.Caption), MB_OK);
    MessageBox(Handle,'    .','',8240);
    Raise;
  end; {try}
  if not Obj.Active then exit;
  cbOnBeginDay.Checked := Obj.OnBeginDay;
  vDate.Date := Obj.DateTime;
  vTime.Time := Obj.DateTime;
  //fAktualHist.dtAfter.DateTime := obj.DateTime;
  //fAktualHist.dtBefore.DateTime := obj.DateTime;
  qObjs.Active := true;
  Props.Active := true;
  //cnn.Open;

  //qObjs.Open;
  //Props.Open;

  sg.DefaultRowHeight := RowHeights;
  UpdProps;

  Obj.ExtractNames(cnn.ConnectionString , NamBD , NamSrv);
  Caption := ' BD << '+NamSrv+' : '+NamBD+' >>';

end;

procedure TfMain.tbReqObjsClick(Sender: TObject);
begin
  if not Obj.Active then exit;
  qObjs.Requery();
end;

procedure TfMain.gObjsKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  UpdProps;
end;

procedure TfMain.gObjsMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  UpdProps;
end;


procedure TfMain.EndEditValue(SetEditText: String);
var idObj,idProp: integer;
begin
    idObj := qObjs.FieldValues['id'];
    idProp := Obj.GetIdProp[sg.Cells[0,sg.Row]];
    //Obj.Value[idObj,idProp] := SetEditText;
    inc(NumEvent);
    msgTxt := 'NumEvent - '+IntToStr(NumEvent)+#13#10+
              '  Obj - '+IntToStr(idObj)+', Prop - '+IntToStr(idProp)+#13#10+
              '  '+sg.Cells[0,sg.Row]+' = '+SetEditText; //sg.Cells[1,sg.Row];
    msg.Lines.Append(msgTxt);
end;

procedure TfMain.UpdateOptions(const Grid: TStringGrid;
  const Combo: TfsComboBox; const ACol, ARow: Integer);
var
  lR, lName : TRect;
begin

  if ACol = OPTION_NAME_COL then
    Combo.ItemIndex := Combo.Items.IndexOf(Grid.Cells[ACol+1,ARow])
  else
    if ACol = OPTION_VALUE_COL then
      Combo.ItemIndex := Combo.Items.IndexOf(Grid.Cells[ACol,ARow]);

  Combo.Tag := ARow;
  if ACol = OPTION_NAME_COL then
  begin
    lName := Grid.CellRect(ACol, ARow);
    lR := Grid.CellRect(ACol + 1, ARow);
  end
  else
  begin
    lName := Grid.CellRect(ACol - 1, ARow);
    lR := Grid.CellRect(ACol, ARow);
  end;

  // lName := sgOptions.CellRect(ACol, ARow);
  lName.Left := lName.Left + Grid.Left;
  lName.Right := lName.Right + Grid.Left;
  lName.Top := lName.Top + Grid.Top;
  lName.Bottom := lName.Bottom + Grid.Top;

  // lR := sgOptions.CellRect(ACol, ARow);
  lR.Left := lR.Left + Grid.Left;
  lR.Right := lR.Right + Grid.Left;
  lR.Top := lR.Top + Grid.Top;
  lR.Bottom := lR.Bottom + Grid.Top;
  Combo.Left := lR.Left + 1;
  Combo.Top := lR.Top + 1;
  Combo.Width := (lR.Right + 1) - lR.Left;
  Combo.Height := (lR.Bottom + 1) - lR.Top;
  Combo.SetFocus;
end;

procedure TfMain.sgSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  cbValue.Visible := true;
  cbValue.Text := sg.Cells[ACol, ARow];
  UpdateOptions(sg, cbValue, ACol, ARow);
end;

procedure TfMain.sgDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
const
  INDENT = 2;
var
  lLeft: integer;
  lText: string;
begin
  with (Sender as TStringGrid).canvas do
  begin
    if ACol = OPTION_VALUE_COL then
    begin
      //font.color := clBlue;
      if brush.color = clHighlight then
        font.color := clWhite;
      lText := (Sender as TStringGrid).Cells[ACol,ARow];
      lLeft := Rect.Left + INDENT;
      TextRect(Rect, lLeft, Rect.top + INDENT, lText);
    end;
  end;
end;

procedure TfMain.cbValueExit(Sender: TObject);
var
  idObj,idProp,idRow: integer;
  OldVal,NewVal: string;
begin

  idRow := cbValue.Tag;
  OldVal := sg.Cells[OPTION_VALUE_COL,idRow];
  NewVal := cbValue.Text;

  if not (OldVal = NewVal) then
  begin
    idObj := qObjs.FieldValues['id'];
    idProp := Obj.GetIdProp[sg.Cells[0,idRow]];
    Obj.Value[idObj,idProp] := NewVal;
    {
    inc(NumEvent);
    msgTxt := 'NumEvent - '+IntToStr(NumEvent)+#13#10+
              '  Obj - '+IntToStr(idObj)+', Prop - '+IntToStr(idProp)+#13#10+
              '  '+OldVal+' = '+NewVal;
    msg.Lines.Append(msgTxt);
    }
  end;

  sg.Cells[OPTION_VALUE_COL,idRow] := cbValue.Text;
  cbValue.Visible := false;
end;

procedure TfMain.vDateChange(Sender: TObject);
begin
  ChangeDateTime;
  UpdProps;
end;

procedure TfMain.vTimeChange(Sender: TObject);
begin
  ChangeDateTime;
  UpdProps;
end;

procedure TfMain.cbOnBeginDayClick(Sender: TObject);
begin
  Obj.OnBeginDay := cbOnBeginDay.Checked;
  vTime.Enabled := not Obj.OnBeginDay;
  vDate.Date := Obj.DateTime;
  vTime.Time := Obj.DateTime;
end;

procedure TfMain.tbAddObjClick(Sender: TObject);
begin
  if not Obj.Active then exit;
  Obj.AddObj;
  qObjs.Requery();
end;

procedure TfMain.bHistClick(Sender: TObject);
var
  idObj,idProp,idRow: integer;
  //SQLStr: TStrings;
begin
  try
  idRow := cbValue.Tag;
  idObj := qObjs.FieldValues['id'];
  NamProp := sg.Cells[0,idRow];
  idProp := Obj.GetIdProp[NamProp];
  pHist.Caption := '    '+NamProp+
                   '    id = '+IntToStr(idObj);
  {
  msgTxt := '  Obj - '+IntToStr(idObj)+
            ', Prop - '+IntToStr(idProp)+#13#10;
  msg.Lines.Append(msgTxt);
  }
  //msg.Lines.Append(sql);
  qHist.Active := false;
  qHist.Close;
  qHist.SQL.Clear;
  qHist.SQL.Append(Obj.GetHistSQL[idObj,idProp]);
  qHist.Open;
  qHist.Active := true;
  qHist.Fields[0].Visible := false;
  qHist.Fields[1].Visible := false;
  except
  end;
end;

end.

