unit uObjRel;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ADODB, StdCtrls, Grids, DBGrids, ComCtrls,
  IniFiles, AdoConEd;

type
  TfMain = class(TForm)
    vDate: TDateTimePicker;
    gObjs_: TDBGrid;
    eEdit: TEdit;
    gSub_: TDBGrid;
    cnn: TADOConnection;
    Objs_: TADOStoredProc;
    Objs_id: TAutoIncField;
    Objs_Nam: TWideStringField;
    dsObjs_: TDataSource;
    Sub_: TADOStoredProc;
    Sub_id: TAutoIncField;
    Sub_idSub: TIntegerField;
    Sub_Nam: TWideStringField;
    dsSub_: TDataSource;
    procedure FormCreate(Sender: TObject);
    procedure Objs_AfterScroll(DataSet: TDataSet);
    procedure vDateChange(Sender: TObject);
    procedure gObjs_DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure gObjs_KeyPress(Sender: TObject; var Key: Char);
    procedure Objs_AfterInsert(DataSet: TDataSet);
    procedure Objs_BeforeInsert(DataSet: TDataSet);
  private
    function AttemptConnection: boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fMain: TfMain;
  IniFile: TIniFile;


implementation

{$R *.dfm}

uses uTask;

  var cntAttempts: integer = 0;

function TfMain.AttemptConnection: boolean;
begin
  inc(cntAttempts);
  if cntAttempts = 3 then Application.Terminate;
  result := true;
  try
    cnn.Open;
  except
    result := false;
  end;
end;


procedure TfMain.FormCreate(Sender: TObject);
var
  Path: string;
begin
  try
  //  
  cnn.Close;
  Path := ExtractFileDir(Application.ExeName);
  if Path[Length(Path)]<>'\' then Path := Path + '\';
  IniFile := TIniFile.Create(Path+'cfg.ini');
  cnn.ConnectionString := IniFile.ReadString('Main','StrCnn','');

  if cnn.ConnectionString = '' then EditConnectionString(cnn);
  while not AttemptConnection do
  begin
    EditConnectionString(cnn); //   AdoConEd
  end;
  IniFile.WriteString('Main', 'StrCnn', cnn.ConnectionString);
  with cnn do
  begin
    Open;
    if not Connected then
    begin
     MessageBox(Handle,'      ',
                ' ',16);
    end;
  end;

  ConnectionString := cnn.ConnectionString;
  InitTask;
  vDate.DateTime := Obj.DateTime;
  Objs_.Close;
  Objs_.Parameters.ParamValues['@ta'] := Obj.DateTime;
  Objs_.Open;

  except
  end;
end;

procedure TfMain.Objs_AfterScroll(DataSet: TDataSet);
begin
  if not TaskActive then exit;
  if Objs_id.IsNull then exit;
  Sub_.Close;
  Sub_.Parameters.ParamValues['@ta'] := Obj.DateTime;
  Sub_.Parameters.ParamValues['@idPrPar'] := Objs_id.AsInteger;
  Sub_.Open;
end;

procedure TfMain.vDateChange(Sender: TObject);
begin
  Obj.DateTime := vDate.DateTime;
  Objs_.Close;
  Objs_.Parameters.ParamValues['@ta'] := Obj.DateTime;
  Objs_.Open;
  Sub_.Close;
  Sub_.Parameters.ParamValues['@ta'] := Obj.DateTime;
  Sub_.Open;
end;

procedure TfMain.gObjs_DrawColumnCell(Sender: TObject; const Rect: TRect;
  DataCol: Integer; Column: TColumn; State: TGridDrawState);
var NamF: String;
begin
  //  eEdit
  if (gdFocused in State) then
  begin
    NamF := Column.Field.FieldName;
    if (NamF = 'Nam') then
    begin
      eEdit.Left := Rect.Left + TDBGrid(Sender).Left;
      eEdit.Top := Rect.Top + TDBGrid(Sender).top;
      eEdit.Width := Rect.Right - Rect.Left + 2;
      eEdit.Text := TDBGrid(Sender).SelectedField.AsString;
    end;
  end;
end;

procedure TfMain.gObjs_KeyPress(Sender: TObject; var Key: Char);
var
  NamF: string;
begin
  if (Key = chr(13)) and (not eEdit.Visible) then begin
      NamF := TDBGrid(Sender).SelectedField.FieldName;
      if NamF = 'Nam' then begin
        eEdit.Visible := true;
        eEdit.Text := TDBGrid(Sender).SelectedField.AsString;
        eEdit.SetFocus;
      end;
  end;
end;

procedure TfMain.Objs_AfterInsert(DataSet: TDataSet);
begin
  if not InsOkObjs then
  begin
    DataSet.Cancel;
    exit;
  end;
  Objs_.Requery();
  //Objs_.Locate('id',idCurObj,[loCaseInsensitive]);
  DataSet.RecNo := DataSet.RecordCount;
  Objs_.Cancel;
end;

procedure TfMain.Objs_BeforeInsert(DataSet: TDataSet);
var idObj: integer;
begin
  if DataSet.RecNo < DataSet.RecordCount then
  begin
    InsOkObjs := false;
    exit;
  end;
  if Objs_Nam.AsString = '' then
  begin
    InsOkObjs := false;
    exit;
  end;
  InsOkObjs := true;
  //idCurObj := DataSet.RecNo;
  idObj := Obj.AddObj;
  Obj.Value[idObj,idPrType] := toPerson;
end;

end.
